/***************************************************************************
                          speaker3.cpp  -  description
                             -------------------
    begin                : Thu Jul 11 21:52:05 BST 2002
    copyright            : (C) 2002 by George Russell
    email                : george.russell@clara.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <khtml_part.h> // this plugin applies to a khtml part
#include <kdebug.h>
#include "speaker3.h"
#include <kaction.h>
#include <kinstance.h>
#include <kiconloader.h>
#include <qmessagebox.h>
#include <klocale.h>
#include <kprocess.h>
#include <qstring.h>
#include <kprocio.h>
 
Speaker3::Speaker3( QObject* parent, const char* name )
    : Plugin( parent, name )
{
    (void) new KAction( "&Speaker3 (plugin)",
                        "filter", 0,
                        this, SLOT(slotAction()),
                        actionCollection(), "speaker3" );
}
 
Speaker3::~Speaker3()
{
}

void Speaker3::slotAction()
{
    // The parent is assumed to be a KHTMLPart
  if ( parent() &&  parent()->inherits("KHTMLPart") ) {
      KHTMLPart *part = static_cast<KHTMLPart *> (parent());
        QString query;
        query = part->selectedText();
        if (query.length() == 0){
          part->selectAll();
	  query = part->selectedText(); 
        }
	KProcIO process;
	process << "festival"
		<< "--tts";
	process.writeStdin(query);
	process.start(KProcess::DontCare);
    }
    else
      {
        QString title = i18n( "Cannot Read source" );
        QString text = i18n( "You cannot read anything except web pages with\n"
                             "this plugin, sorry." );
 
       QMessageBox::warning( 0, title, text );
    }
}
KPluginFactory::KPluginFactory( QObject* parent, const char* name )
  : KLibFactory( parent, name )
{
  s_instance = new KInstance("KPluginFactory");
}
 
QObject* KPluginFactory::createObject( QObject* parent, const char* name, const char*, const QStringList & )
{
    QObject *obj = new Speaker3( parent, name );
    return obj;
}
KPluginFactory::~KPluginFactory()
{ delete s_instance; }

 
extern "C"
{
  void* init_libspeaker3()
  {
    return new KPluginFactory;
  }
 
}
 
KInstance* KPluginFactory::s_instance = 0L;
